SystemOrganization addCategory: #'tODE-Debugger'!

TOInspector subclass: #TOContextInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:25'!
context

	^self object! !

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:25'!
context: anObject

	self object: anObject! !

!TOContextInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:41'!
renderMembersOn: html main: main
	html strong: 'Args:'.
	html unorderedList: [self renderBasicMembers: self getArgMembers on: html main: main].
	html strong: 'Method Context:' .
	html unorderedList: [self renderBasicMembers: self getContextMembers on: html main: main].
! !

TOInspector subclass: #TOReceiverInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOReceiverInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:42'!
receiver

	^self object! !

!TOReceiverInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:42'!
receiver: anObject

	self object: anObject! !

!TOReceiverInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:44'!
renderMembersOn: html main: main
	html strong: 'Self:'.
	html unorderedList: [super renderMembersOn: html main: main].
! !

Notification subclass: #TODoItErrorCaught
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

TOView subclass: #TODebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

TODebugger subclass: #TOAbstractProcess
	instanceVariableNames: 'frames topOfStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOAbstractProcess methodsFor: 'accessing' stamp: 'dkh 06/08/2011 15:27'!
createFramesFrom: initialContext
	| context stackFrame next |
	context := initialContext.
	frames := OrderedCollection new.
	topOfStack := stackFrame := (TOStackFrame new) context: context; parent: self; yourself.
	[ context isNil ] whileFalse: [
		frames add: stackFrame.
		context := context sender.
		context ifNotNil: [
			next :=  (TOStackFrame new) context: context; parent: self; yourself.
			stackFrame next: next.
			next previous: stackFrame.
			stackFrame := next ] ].! !

!TOAbstractProcess methodsFor: 'accessing' stamp: 'dkh 06/08/2011 15:27'!
frames

	^frames! !

!TOAbstractProcess methodsFor: 'rendering' stamp: 'dkh 06/08/2011 15:27'!
renderContentOn: html spec: aTOTabSpec main: main

	self subclassResponsibiilty! !

!TOAbstractProcess methodsFor: 'rendering' stamp: 'dkh 06/08/2011 15:27'!
renderStackOn: html spec: aTOSpec main: main

	self renderStackOn: html stackFrame: self main: main
! !

!TOAbstractProcess methodsFor: 'rendering' stamp: 'dkh 06/08/2011 15:27'!
renderStackOn: html stackFrame: aStackFrame main: main

	self frames do: [:fr |
		 | anchor |
			(anchor := html anchor)
				url: '#';
				onClick:
						(html jQuery ajax
								script: [ :s |
									self pushit: fr selecting: #debug main: main.
									main updateCenterSideHistory: s]);
				yourself.
			aStackFrame == fr
				ifTrue: [ anchor with: [:r | r strong: fr printString ]]
				ifFalse: [ anchor with: fr printString ].
			html break. ]! !

!TOAbstractProcess methodsFor: 'accessing' stamp: 'dkh 06/08/2011 15:27'!
topOfStack

	^topOfStack! !

TOAbstractProcess subclass: #TOException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOException methodsFor: 'accessing' stamp: 'dkh 5/28/2011 13:42'!
exception

	^self object! !

!TOException methodsFor: 'accessing' stamp: 'dkh 06/08/2011 14:52'!
label

	^'exception'! !

!TOException methodsFor: 'rendering' stamp: 'dkh 06/08/2011 15:02'!
renderContentOn: html spec: aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	html text: 'An '.
	self
		renderLink: [ :s | 
			self currentSession push: self exception selecting: #inspect.
			main updateCenterSideHistory: s ]
		with: 'exception'
		on: html.
	html text: ':'.
	html
		unorderedList: [ 
			(html heading)
				level: 1;
				with: self exception description ].
	html paragraph: ' has occurred during the execution of the script.'.
	html
		paragraph: [ 
			html text: 'To debug, select '.
			self
				renderLink: [ :s | 
					self currentSession push: self topOfStack selecting: #debug.
					main updateCenterSideHistory: s ]
				with: 'topOfStack'
				on: html.
			html text: ' or a frame from the list on your left.' ]! !

!TOException methodsFor: 'accessing' stamp: 'dkh 6/14/2011 08:47'!
tODEDebugFrameTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #debug;
		receiver: self;
		label: 'debug';
		order: 75;
		group: 'basic';
		sidebarSpec: self tODEDebugFrameSidebarSpec;
		renderSelector: #renderContentOn:spec:main:! !

!TODebugger methodsFor: 'accessing' stamp: 'dkh 6/14/2011 08:46'!
tODEDebugFrameSidebarSpec

	^ {(TOTabSpec new)
		id: #debug;
		receiver: self;
		label: 'stack';
		order: 50;
		group: 'basic';
		renderSelector: #renderStackOn:spec:main:}! !

TODebugger subclass: #TOStackFrame
	instanceVariableNames: 'parent exception previous context next receiver stackHome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Debugger'!

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
context
	^ context! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
context: anObject

	receiver := anObject receiver.
	context := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:29'!
home

	| home stackFrame  |
	stackHome ifNotNil: [ ^stackHome ].
	(home := self context home) == self context
		ifTrue: [ ^stackHome := nil ].
	stackFrame := self next.
	[ stackFrame notNil ] whileTrue: [
		stackFrame context home == home ifTrue: [ ^stackHome := stackFrame ].
		stackFrame := stackFrame next ].
	^stackHome := nil! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 6/16/2011 16:13'!
methodClass

	^self context method methodClass! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 6/23/2011 08:51'!
methodReference
	self methodSelector == #DoIt
		ifTrue: [ ^ MethodReference class: self methodClass selector: self methodSelector ].
	^ SourcedMethodReference class: self methodClass selector: self methodSelector! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 6/16/2011 16:13'!
methodSelector

	^self context method selector! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 19:05'!
methodSource

	^self context sourceCode! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
next
	^ next! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
next: anObject
	next := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 06/08/2011 14:50'!
parent
	^ parent! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 06/08/2011 14:50'!
parent: anObject
	parent := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 6/24/2011 12:02'!
pcRange
	"Answer the indices in the source code for the method corresponding to the selected context's program counter value."

	self context isDead
		ifTrue: [ ^ 1 to: 0 ].
	^ [ self context debuggerMap rangeForPC: self context pc contextIsActiveContext: previous == nil ]
		on: UndeclaredVariableWarning
		do: [ :ex | ex return: (1 to: 0) ]! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
previous
	^ previous! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
previous: anObject
	previous := anObject! !

!TOStackFrame methodsFor: 'printing' stamp: 'dkh 05/21/2011 04:18'!
printContext: aContext on: aStream
	| outerContext |
	(outerContext := aContext outerContext)
		ifNil: [aContext  printOn: aStream]
		ifNotNil:
			[
			 aStream nextPutAll: ' [] in '.
			 self printContext: outerContext on: aStream]! !

!TOStackFrame methodsFor: 'printing' stamp: 'dkh 5/28/2011 18:14'!
printOn: aStream
	self printContext: self context on: aStream! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:16'!
receiverClass

	^self context receiver class! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 6/16/2011 16:34'!
renderContentOn: html spec:  aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	self renderFrameNavigationOn: html main: main.
	html break.
	self context renderViewOn: html for: self main: main.
	html break.
	self renderMethodSourceOn: html main: main.
	html horizontalRule.
	((TOContextInspector new)
		object: self context;
		frame:  aTOTabSpec frame) renderMembersOn: html main: main.
	html horizontalRule.
	((TOReceiverInspector new)
		receiver: self context receiver;
		frame:  aTOTabSpec frame) renderMembersOn: html main: main.
! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 06/08/2011 15:02'!
renderFrameNavigationOn: html main: main
	self
		renderButton: [ :s | 
			self currentSession push: self parent selecting: #debug.
			main updateCenterSideHistory: s ]
		label: self parent label
		on: html.
	html break.
	self previous isNil
		ifTrue: [ html text: '<<' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					self currentSession push: self previous selecting: #debug.
					main updateCenterSideHistory: s ]
				label: '<<'
				on: html ].
	html text: ' frames '.
	self next isNil
		ifTrue: [ html text: '>>' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					self currentSession push: self next selecting: #debug.
					main updateCenterSideHistory: s ]
				label: '>>'
				on: html ].
	self home
		ifNotNil: [ :home | 
			self
				renderButton: [ :s | 
					self currentSession push: self home selecting: #debug.
					main updateCenterSideHistory: s ]
				label: 'home context'
				on: html ].
	html break! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 6/23/2011 15:11'!
renderMethodSourceOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			| pcRange |
			pcRange := self pcRange.
			(html textArea)
				id: id;
				columns: (self textAreaColumns: self methodSource);
				rows: (self textAreaRows: self methodSource);
				value: self methodSource;
				onMouseOver:
						((html jQuery ajax)
								callback: [ :value |  ]
									value: (JSStream on: 'selectionStart = ' , (pcRange first - 1) printString);
								callback: [ :value |  ]
									value: (JSStream on: 'selectionEnd = ' , pcRange last printString)) ]
		on: html! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 06/08/2011 15:03'!
renderStackOn: html spec: aTOTabSpec main: main

	self parent renderStackOn: html stackFrame: self main: main! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 6/23/2011 14:23'!
renderStyledMethodSourceOn: html main: main
	| methodReferenceView fr |
	methodReferenceView := TOMethodReference new methodReference: self context.
	fr := self currentSession findFrameFor: methodReferenceView.
	methodReferenceView frame: self frame.
	methodReferenceView
		renderControl: [ :id :scrpt | methodReferenceView renderHighlightMethodSourceOn: html main: main ]
		on: html.
        html break.
        methodReferenceView renderCheckBoxesOn: html main: main! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 6/14/2011 08:47'!
tODEDebugFrameTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #debug;
		receiver: self;
		label: 'debug';
		order: 75;
		group: 'basic';
		sidebarSpec: self tODEDebugFrameSidebarSpec;
		renderSelector: #renderContentOn:spec:main:! !
